-- Arm Vehicle Plant Script

createUnitScript("arm_t3_usi_kbots")

__this:piece( "Corps", "Pad", "Tir1", "Tir2", "Tir3", "Base1", "Base2", "Base3", "Bras1", "Bras2", "Bras3", "Avantbras1", "Avantbras2", "Avantbras3", "Nano1", "Nano2", "Nano3", "Tir1", "Tir2", "Tir3", "Moyeu1", "Moyeu2", "Roue1", "Roue2", "Cylindre" )

__this.SIG_ACTIVATE = 2
__this.SMOKEPIECE1 = __this.Corps
__this.ANIM_VARIABLE = true

#include "exptype.lh"
#include "StateChg.lh"
#include "smokeunit.lh"
#include "yard.lh"

__this.activatescr = function (this)
end

__this.deactivatescr = function (this)
end

__this.Go = function (this)
	this:activatescr()
	this:OpenYard()
	this:set( INBUILDSTANCE, true )
end

__this.Stop = function(this)
	this:set( INBUILDSTANCE, false )
	this:CloseYard()
	this:deactivatescr()
end

__this.ACTIVATECMD = __this.Go
__this.DEACTIVATECMD = __this.Stop

__this.Create = function(this)
	this.spray = 0
	this:InitState()
	this:start_script( this.SmokeUnit, this )
end

__this.QueryNanoPiece = function(this, piecenum)
	if this.spray == 0 then
		piecenum = this.Tir1
	elseif this.spray == 1 then
		piecenum = this.Tir2
	else
		piecenum = this.Tir3
	end
	this.spray = (this.spray + 1) % 3
	return piecenum
end

__this.Activate = function(this)
	this:signal( this.SIG_ACTIVATE )
	this:start_script( this.RequestState, this, ACTIVE )
end

__this.Deactivate = function(this)
	this:signal( this.SIG_ACTIVATE )
	set_signal_mask( this.SIG_ACTIVATE )
	sleep( 5 )
	set_signal_mask( 0 )
	this:start_script( this.RequestState, this, INACTIVE )
end

__this.StartBuilding = function(this)
 	this:spin( this.Moyeu1, y_axis, -60,2 )
	this:spin( this.Roue1, y_axis, 90,2 )
	this:spin( this.Moyeu2, y_axis, 60,2 )
	this:spin( this.Roue2, y_axis, -90,2 )
	this:spin( this.Cylindre, z_axis, 40,2 )
end

__this.StopBuilding = function(this)
	this:stop_spin( this.Moyeu1, y_axis,1 )
	this:stop_spin( this.Roue1, y_axis,1 )
	this:stop_spin( this.Moyeu2, y_axis,1 )
	this:stop_spin( this.Roue2, y_axis,1 )
	this:stop_spin( this.Cylindre, z_axis,1 )
end

__this.QueryBuildInfo = function(this, piecenum)
	return this.Pad
end

__this.SweetSpot = function (this,piecenum)
	return this.Corps
end

__this.Killed = function(this, severity )
	if severity <= 25 then
		return 1
	end

	if severity <= 50 then
		return 2
	end

	if severity <= 99 then
		return 3
	end

	return 3
end

